#ifndef PIECES_H_INCLUDED
#define PIECES_H_INCLUDED

#include "Piece.h"
#include "TetrisWindow.h"

/**
 * @class Piece_I
 * @author zsmb
 * @brief The I shaped piece of tetris
 */
class Piece_I : public Piece {
    static Uint32 colour; //!< Colour stored as 0xRRGGBBAA value
public:
    Piece_I(int x_pos, const TetrisWindow* containing_window);
    void rotate();
};

/**
 * @class Piece_J
 * @author zsmb
 * @brief The J shaped piece of tetris
 */
class Piece_J : public Piece {
    static Uint32 colour;                  //!< Colour stored as 0xRRGGBBAA value
    static const char rotation_matrix[24]; //!< Matrix containing the numbers used in Piece::rotate
public:
    Piece_J(int x_pos, const TetrisWindow* containing_window);
};

/**
 * @class Piece_L
 * @author zsmb
 * @brief The L shaped piece of tetris
 */
class Piece_L : public Piece {
    static Uint32 colour;                  //!< Colour stored as 0xRRGGBBAA value
    static const char rotation_matrix[24]; //!< Matrix containing the numbers used in Piece::rotate
public:
    Piece_L(int x_pos, const TetrisWindow* containing_window);
};

/**
 * @class Piece_O
 * @author zsmb
 * @brief The O shaped piece of tetris
 */
class Piece_O : public Piece {
    static Uint32 colour; //!< Colour stored as 0xRRGGBBAA value
public:
    Piece_O(int x_pos, const TetrisWindow* containing_window);
    void rotate();
};

/**
 * @class Piece_S
 * @author zsmb
 * @brief The S shaped piece of tetris
 */
class Piece_S : public Piece {
    static Uint32 colour;                  //!< Colour stored as 0xRRGGBBAA value
    static const char rotation_matrix[24]; //!< Matrix containing the numbers used in Piece::rotate
public:
    Piece_S(int x_pos, const TetrisWindow* containing_window);
};

/**
 * @class Piece_T
 * @author zsmb
 * @brief The T shaped piece of tetris
 */
class Piece_T : public Piece {
    static Uint32 colour;                  //!< Colour stored as 0xRRGGBBAA value
    static const char rotation_matrix[24]; //!< Matrix containing the numbers used in Piece::rotate
public:
    Piece_T(int x_pos, const TetrisWindow* containing_window);
};

/**
 * @class Piece_Z
 * @author zsmb
 * @brief The Z shaped piece of tetris
 */
class Piece_Z : public Piece {
    static Uint32 colour;                  //!< Colour stored as 0xRRGGBBAA value
    static const char rotation_matrix[24]; //!< Matrix containing the numbers used in Piece::rotate
public:
    Piece_Z(int x_pos, const TetrisWindow* containing_window);
};

#endif // PIECES_H_INCLUDED
